"""
Contains abstract class for a mirrored project
"""

from abc import ABC

import requests

from shared import CSC_MIRROR


class Project(ABC):
	"""Abstract class for a mirrored project"""

	@staticmethod
	def check(data, project):
		"""Check if project packages are up-to-date"""
		csc_url = CSC_MIRROR + data[project]["csc"] + data[project]["file"]
		upstream_url = data[project]["upstream"] + data[project]["file"]
		return requests.get(csc_url).text == requests.get(upstream_url).text
